<template>
  <div class="comments">
    <h1 class="title is-5">{{comments.length}} comments</h1>
    <article class="media" v-for="comment in comments" v-bind:key="comment.id">
      <div class="media-content">
        <div class="content">
          <p>
            <strong>{{comment.author.username}}</strong> - <small>{{new Date(comment.added).toLocaleDateString()}}</small>
            <br>
            {{comment.content}}
          </p>
        </div>
      </div>
      <div class="media-right details" v-if="isAdmin">
        <b-button class="actionButton" icon-left="delete" type="is-danger" @click="removePrompt(comment.id)" outlined/>
      </div>
    </article>

    <div v-if="isLoggedIn">
      <hr>
      <b-field label="Add a comment">
        <b-input maxlength="1000" type="textarea" v-model="postContent"/>
      </b-field>
      <b-field>
        <b-button @click="postComment">Post</b-button>
      </b-field>
    </div>
  </div>
</template>

<script>
import { api } from '@/api.js'

export default {
  name: 'Comments',
  props: ['modelId'],
  data () {
    return {
      isLoggedIn: false,
      isLoading: true,
      isAdmin: false,
      comments: [],
      postContent: ''
    }
  },
  async mounted () {
    this.comments = await api.getModelComments(this.modelId)

    const userRole = await localStorage.getItem('user_role')
    if (userRole) this.isLoggedIn = true
    if (userRole === 'ADMIN') this.isAdmin = true
  },
  methods: {
    async postComment () {
      await api.addComment(this.modelId, this.postContent)
      this.comments = await api.getModelComments(this.modelId)
      this.postContent = null
    },
    removePrompt (id) {
      this.$buefy.dialog.confirm({
        message: 'Delete comment ?',
        cancelText: 'Abort',
        confirmText: 'Delete',
        type: 'is-danger',
        hasIcon: true,
        onConfirm: async () => {
          await api.removeComment(id)
          this.comments = await api.getModelComments(this.modelId)
          this.$buefy.toast.open('Comment deleted')
        }
      })
    }
  }
}
</script>

<style>

</style>
